//////////////////////////////
// add_parent.c
// written by Michael Gibson
// released under the GPL
// enter the father and mother of an individual
// copyright 2005-2015
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

 void readfile(void);
 void writefile(void);

 char indi_name_s_f[95];
 int  indi_name_f;
 char indi_sname_s_f[95];
 int  indi_sname_f;
 char indi_name_s_m[95];
 int  indi_name_m;
 char indi_sname_s_m[95];
 int  indi_sname_m;
 char indi_birthdate_s_f[90];
 int  indi_birthdate_f;
 char indi_birthdate_s_m[90];
 int  indi_birthdate_m;

 char fami_marrdate[90];
 int  fami_marrdate_i;

 char indi_check[55];
 int indi_passed;             //last individual number read/passed in
 int last_read_indi;
 int newid;                   //id of the individual being added
 int last_read_fami;
 int newfami;                 //id of the new family created

 char filename[55];
 char temp[80];               //data that is read in and evaluated

 int number_of_names;
 int number_of_lines;
 int family_begin;
 int x; //loop var

 //for up to 99999 lines read in at the length up to 80
 char data_line[99999][80];


////////////////////////////////////////
//
//////////////////////////////////////
static void submit(void)
{

  char string_1[50];

  //printf("submit pressed \n");

  writefile();

  system("killall gedlist");
  sprintf(string_1,"./gedlist %s &",filename);
  //printf("%s\n",string_1);
  system(string_1);
  exit(0);
}

/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
static void destroy(void)
{
    gdx_closewindow();
}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){


  int  dad_image, mom_image;

  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03;
  int label0,label1,label2,label3,label4,label5,label6,label7,label9;
  char label_string1[60];
  char label_string2[60];
  int flag1=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[2]);
  readfile();

  //printf("Start GUI\n");

  system("killall gedtree");
  x_open();

  /* create a new window */
  gdx_window("GEDCOM Add Parent",510,410);
  gdx_setwindowbg("images/bg.xpm",1);

  button_01 = gdx_imagebutton(5,10,"images/close.xpm",destroy);
  button_02 = gdx_imagebutton(5,40,"images/filesave.xpm",submit);
  button_03 = gdx_imagebutton(55,380,"images/submit.xpm",submit);

  dad_image=gdx_image(130,35, "images/addfather2.xpm");  
  mom_image=gdx_image(130,170, "images/addmother2.xpm");

  sprintf(label_string1,"Saving to filename %s",argv[2]);
  label0 = gdx_label(label_string1,50,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  sprintf(label_string2,"Parents of %s id %s",argv[3],argv[1]);
  label7 = gdx_label(label_string2,50,30,1);
  gdx_setlabelbg("images/white.xpm",1,label7);  

  //printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  indi_passed=atoi(argv[1]);

  //father entry first

  label1 = gdx_label("Given Name:",45,95,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name_f=gdx_textentry(135,85,200,0);

  label2=gdx_label("Surname:",45,120,0);
  gdx_setlabelbg("images/bg.xpm",1,label2);
  indi_sname_f=gdx_textentry(135,110,200,0);

  label3=gdx_label("Birth Date:",45,145,0);
  gdx_setlabelbg("images/bg.xpm",1,label3); 
  indi_birthdate_f=gdx_textentry(135,135,100,0);

  //mother entry next

  label4 = gdx_label("Given Name:",45,230,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_name_m=gdx_textentry(135,220,200,0);

  label5=gdx_label("Surname:",45,255,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);
  indi_sname_m=gdx_textentry(135,245,200,0);

  label6=gdx_label("Birth Date:",45,280,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  indi_birthdate_m=gdx_textentry(135,270,100,0);


  gdx_frame(45,320,445,370,"Marriage");


  label9=gdx_label("Marriage Date:",55,345,0);
  gdx_setlabelbg("images/bg.xpm",1,label9);
  fami_marrdate_i=gdx_textentry(145,335,100,0);

  gdx_main();
  x_close();

  return(0);
}


////////////////////////////////////////////////////////
// read file
////////////////////////////////////////////////////////

void readfile(void)
{

  int theend=0;      //if end of data found, stop reading

  int familyfound=0; //if a family is found, stop looking

  FILE *fp; 
  if((fp=fopen(filename,"r"))==NULL ){
     printf("GEDCOM add parent : Sorry, no file found. \n");
     exit(0);
  }
  number_of_names = 0;
  number_of_lines = 0;
  do{
    fgets(temp,80,fp);
    number_of_lines++;
    strcpy(data_line[number_of_lines],temp);

    //clean up returns
    for(x=0;x<80;x++){
      if(temp[x]=='\r' || temp[x]=='\n'){
         temp[x]= ' ';
      }
    }

    // Look for indivduals
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){         //Individual 0 level start of record
      temp[0]=' ';
      for(x=0;x<80;x++){
        if(temp[x]=='@' || temp[x]=='I' ||temp[x]=='N' ||temp[x]=='D') temp[x]=' ';
      }
      last_read_indi=atoi(temp);
      number_of_names++;
    } //end if


   //Look for family start
   if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F' && familyfound==0){
     family_begin=number_of_lines;
     familyfound=1;
   }

  //look for last family id
   if(temp[0]=='0' && temp[2]=='@' && temp[3]=='F'){
      temp[0]=' ';
      for(x=0;x<80;x++){
        if(temp[x]=='@' || temp[x]=='F' ||temp[x]=='A' ||temp[x]=='M' || temp[x]=='I') temp[x]=' ';
      }
      last_read_fami=atoi(temp);
   }

   //find end
   if(temp[0] == '0' && temp[2] == 'T' && temp[3] == 'R'){
     theend=1;
   }
  //printf(".");

  }while (theend != 1); //end do

  //printf("\nNumber of lines = %d \n",number_of_lines);
  //printf("Number of names = %d \n",number_of_names);
  //printf("Last read ID=%d \n",last_read_indi);
  newid=last_read_indi + 1;
  //printf("Last read family ID=%d \n",last_read_fami);
  newfami=last_read_fami + 1;
  //printf("new person to have ID of %4d \n",newid);
  //printf("new family to have ID of %4d \n",newfami);
  //printf("Line %d is where families begin \n",family_begin);
  //lastline
}


//////////////////////////////
//
/////////////////////////////
void writefile(void)
{
  char fami_string[15];
  char husb_string[15];
  char wife_string[15];
  char chil_string[15];
  char fath_string[15];
  char moth_string[15];
  char marr_string[15];

  int y; // loop var

  char indi[10];
  int indi_r;

  char fam_lnk[15];     //indivudual's link to family
 
  char fath_name[80];
  char moth_name[80];

  char f_bd[20];
  char m_bd[20];

  //collect data from text entry widgets
  strcpy(indi_name_s_f , gdx_textentry_obj.string[indi_name_f]);
  strcpy(indi_sname_s_f   , gdx_textentry_obj.string[indi_sname_f]);
  strcpy(indi_birthdate_s_f  , gdx_textentry_obj.string[indi_birthdate_f]);
  strcpy(indi_name_s_m , gdx_textentry_obj.string[indi_name_m]);
  strcpy(indi_sname_s_m   , gdx_textentry_obj.string[indi_sname_m]);
  strcpy(indi_birthdate_s_m  , gdx_textentry_obj.string[indi_birthdate_m]);
  strcpy(fami_marrdate,  gdx_textentry_obj.string[fami_marrdate_i]);
  //shift data to write two new individuals
  for(x=number_of_lines;x>=family_begin;x--){
    strcpy(data_line[x+12],data_line[x]);
  }

  number_of_lines = number_of_lines +12;

  //format the new data to write
  //father first
  //format:
  // 0 @I0001@ INDI
  // 1 NAME Billy Bob /Johnson/
  // 1 SEX M
  // 1 BIRT
  // 2 DATE 10 Jun 1959
  // 1 FAMS @F0009@

  sprintf(fath_string,"0 @I%04d@ INDI\n",newid);
  strcpy(data_line[family_begin],fath_string);
  sprintf(fath_name,"1 NAME %s /%s/ \n",indi_name_s_f,indi_sname_s_f);
  strcpy(data_line[family_begin+1],fath_name);
  strcpy(data_line[family_begin+2],"1 SEX M\n");
  strcpy(data_line[family_begin+3],"1 BIRT\n");
  sprintf(f_bd,"2 DATE %s\n",indi_birthdate_s_f);
  strcpy(data_line[family_begin+4],f_bd);
  sprintf(fam_lnk,"1 FAMS @F%04d@\n",newfami);
  strcpy(data_line[family_begin+5],fam_lnk);

  //mother second
  sprintf(moth_string,"0 @I%04d@ INDI\n",newid+1);
  strcpy(data_line[family_begin+6],moth_string);
  sprintf(moth_name,"1 NAME %s /%s/ \n",indi_name_s_m,indi_sname_s_m);
  strcpy(data_line[family_begin+7],moth_name);
  strcpy(data_line[family_begin+8],"1 SEX F\n");
  strcpy(data_line[family_begin+9],"1 BIRT\n");
  sprintf(m_bd,"2 DATE %s\n",indi_birthdate_s_m);
  strcpy(data_line[family_begin+10],m_bd);
  sprintf(fam_lnk,"1 FAMS @F%04d@\n",newfami);
  strcpy(data_line[family_begin+11],fam_lnk);

  // 0 @F0151@ FAM
  // 1 HUSB @I0403@
  // 1 WIFE @I0426@
  // 1 CHIL @I0407@
  // 1 MARR
  // 2 DATE 2 Jun 2007
  //family
  sprintf(fami_string,"0 @F%04d@ FAM\n",newfami);
  strcpy(data_line[number_of_lines],fami_string);
  sprintf(husb_string,"1 HUSB @I%04d@\n",newid);
  strcpy(data_line[number_of_lines+1],husb_string); 
  sprintf(wife_string,"1 WIFE @I%04d@\n",newid + 1);
  strcpy(data_line[number_of_lines+2],wife_string);
  sprintf(chil_string,"1 CHIL @I%04d@\n",indi_passed);
  strcpy(data_line[number_of_lines+3],chil_string);
  strcpy(data_line[number_of_lines+4],"1 MARR\n");
  sprintf(marr_string," 2 DATE %s\n",fami_marrdate);
  strcpy(data_line[number_of_lines+5],marr_string);
  strcpy(data_line[number_of_lines+6],"0 TRLR\n");

  FILE *fp;
  if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add parent : Sorry, no file found. \n");
     exit(0);
  }


  //write data
  for(x=1;x<=number_of_lines+6;x++){

    //find place to write child entry under indivdual if an
    //individual follows

    //copy to evaluated
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){

      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual after the child?
      if(indi_r == (indi_passed +1)){
        //if yes, add child link
        sprintf(data_line[x],"1 FAMC @F%04d@\n%s",newfami,temp);
      }
    }
    //write_data
   // printf("line %d ::%s::",x,data_line[x]);
    fprintf(fp,"%s",data_line[x]);
  }
  fclose(fp);
}
