//////////////////////////////
// gdx_indi.c
// written by Michael Gibson
// released under the GPl
// (c) 2004-2017
//////////////////////////////

#include <stdio.h>
#include <string.h>
#include "GDXlib.h"

 char indi_check[6];
 char indi_num[6];
 char filename[55];

 //9999 charcters by 9999 lines
 //this clears up memory problems with really large GEDCOM files
 char data_line[9999][9999];
 int number_of_lines=0;

// char indi_refn[95];     //REFN =reference(user-defined key)
// int  indi_refn_t;

 char indi_name[95];       //NAME = first middle last(surname) name
 char indi_name_tmp[95];
 int  indi_name_t=0;
 int  indi_name_m=0;
 int  flex_name;

 char indi_nick[95];       //NICK = Nickname = another name the indi went by
 char indi_nick_tmp[95];
 int  indi_nick_t=0;
 int  indi_nick_m=0;

 char indi_alia[95];       //ALIA = Alias = another name the indi was known by
 char indi_alia_tmp[95];
 int  indi_alia_t=0;
 int  indi_alia_m=0;

 char indi_titl[95];       //TITL = title like Captain or Doctor
 char indi_titl_tmp[95];
 int  indi_titl_t=0;
 int  indi_titl_m=0;
 int  flex_titl;

 char indi_sex[7];
 int  indi_sex_t=0;

 char indi_dscr[95];
 char indi_dscr_tmp[95];
 int  indi_dscr_t=0;
 int  indi_dscr_m=0;
 int  flex_dscr;

 char indi_note[95];
 char indi_note_tmp[95];
 int  indi_note_t=0;
 int  indi_note_m=0;
 int  flex_note;

 char indi_birt_date[90];
 char indi_birt_date_tmp[90];
 int  indi_birt_date_t=0;
 int  indi_birt_date_m=0;
 int  flex_birt_date;

 char indi_birt_plac[90];
 char indi_birt_plac_tmp[90];
 int  indi_birt_plac_t=0;
 int  indi_birt_plac_m=0;
 int  flex_birt_plac;

 char indi_birt_note[95];
 char indi_birt_note_tmp[95];
 int  indi_birt_note_t=0;
 int  indi_birt_note_m=0;
 int  flex_birt_note;

 char indi_deat_date[90];
 char indi_deat_date_tmp[90];
 int  indi_deat_date_t=0;
 int  indi_deat_date_m=0;
 int  flex_deat_date;

 char indi_deat_plac[90];
 char indi_deat_plac_tmp[90];
 int  indi_deat_plac_t;
 int  indi_deat_plac_m;
 int  flex_deat_plac;

 char indi_deat_note[95];
 char indi_deat_note_tmp[95];
 int  indi_deat_note_t;
 int  indi_deat_note_m;
 int  flex_deat_note;

 char indi_buri_date[90];
 char indi_buri_date_tmp[90];
 int  indi_buri_date_t;
 int  indi_buri_date_m;
 int  flex_buri_date;

 char indi_buri_plac[90];
 char indi_buri_plac_tmp[90];
 int  indi_buri_plac_t;
 int  indi_buri_plac_m;
 int  flex_buri_plac;

 char indi_buri_note[95];     // final value
 char indi_buri_note_tmp[95]; // stored value
 int  indi_buri_note_t;       // text box widget for value
 int  indi_buri_note_m;       // toggle value
 int  flex_buri_note;         // toggle button widget 

 char indi_addr[95];
 char indi_addr_tmp[95];
 int  indi_addr_t;
 int  indi_addr_m;
 int  flex_addr;

 char indi_educ[95];
 char indi_educ_tmp[95];
 int  indi_educ_t;
 int  indi_educ_m;
 int  flex_educ;

 char indi_occu[95];
 char indi_occu_tmp[95];
 int  indi_occu_t;
 int  indi_occu_m;
 int  flex_occu;

 char indi_reli[95];
 char indi_reli_tmp[95];
 int  indi_reli_t;
 int  indi_reli_m;
 int  flex_reli;

#include "markdata.c"


/////////////////////////////////////////////////////
///// quit app
/////////////////////////////////////////////////////
void destroy(void)
{

    char systemstring[50];
    sprintf(systemstring, "./gedlist %s &",filename);
    system("killall gedlist");
    system(systemstring);
    gdx_closewindow();
}


////////////////////////////////////////////////////
//// family
///////////////////////////////////////////////////
void family(void)
{

  char systemstring[164];

  sprintf(systemstring,"./gedchild %s %s 1 &",indi_num,filename);
  system(systemstring);
}
////////////////////////////////////////////////////
//
///////////////////////////////////////////////////
void parent(void)
{

  char systemtext[60];

  sprintf(systemtext,"./gedtree %s %s &",filename, indi_num);

  system(systemtext);

}

void help(void)
{
 
  x_imgbox("images/helptext.xpm","Help");

}


//////////////////////////////
// save
// save individual data
/////////////////////////////
void save(void)
{
  FILE *fp;
  int data_written=0;       //any data written

  int name_written=0;
  int name_needs_written=0;
  int occu_written=0;
  int occu_needs_written=0;
  int titl_written=0;
  int titl_needs_written=0;
  int nick_written=0;
  int nick_needs_written=0;
  int alia_written=0;
  int alia_needs_written=0;
  int dscr_written=0;
  int dscr_needs_written=0;
  int addr_written=0;
  int addr_needs_written=0;
  int educ_written=0;
  int educ_needs_written=0;
  int reli_written=0;
  int reli_needs_written=0;
  int note_written=0;
  int note_needs_written=0;
  int birt_written=0;
  int birt_needs_written=0;
  int deat_written=0;
  int deat_needs_written=0;
  int buri_written=0;
  int buri_needs_written=0;

  char temp[200];
  int x=0;
  int y=0; // loop var
  char indi[10];
  int indi_r=0;
  int write_indi=0;

  //collect data from text entry widgets
  strcpy(indi_name_tmp, gdx_textentry_obj.string[indi_name_t]);
  strcpy(indi_occu_tmp, gdx_textentry_obj.string[indi_occu_t]);
  strcpy(indi_reli_tmp, gdx_textentry_obj.string[indi_reli_t]);
  strcpy(indi_educ_tmp, gdx_textentry_obj.string[indi_educ_t]);
  strcpy(indi_addr_tmp, gdx_textentry_obj.string[indi_addr_t]);
  strcpy(indi_note_tmp, gdx_textentry_obj.string[indi_note_t]);
  strcpy(indi_nick_tmp, gdx_textentry_obj.string[indi_nick_t]);
  strcpy(indi_alia_tmp, gdx_textentry_obj.string[indi_alia_t]);
  strcpy(indi_dscr_tmp, gdx_textentry_obj.string[indi_dscr_t]);
  strcpy(indi_titl_tmp, gdx_textentry_obj.string[indi_titl_t]);
  
  strcpy(indi_birt_plac_tmp, gdx_textentry_obj.string[indi_birt_plac_t]);
  strcpy(indi_birt_date_tmp, gdx_textentry_obj.string[indi_birt_date_t]);
  strcpy(indi_birt_note_tmp, gdx_textentry_obj.string[indi_birt_note_t]);

  strcpy(indi_deat_plac_tmp, gdx_textentry_obj.string[indi_deat_plac_t]);
  strcpy(indi_deat_date_tmp, gdx_textentry_obj.string[indi_deat_date_t]);
  strcpy(indi_deat_note_tmp, gdx_textentry_obj.string[indi_deat_note_t]);

  strcpy(indi_buri_plac_tmp, gdx_textentry_obj.string[indi_buri_plac_t]);
  strcpy(indi_buri_date_tmp, gdx_textentry_obj.string[indi_buri_date_t]);
  strcpy(indi_buri_note_tmp, gdx_textentry_obj.string[indi_buri_note_t]);

  //if the field contains data and the data has changed
  if(strlen(indi_name_tmp) >= 2 && strcmp(indi_name,indi_name_tmp)!=0) name_needs_written=1;
  if(strlen(indi_occu_tmp) >= 2 && strcmp(indi_occu,indi_occu_tmp)!=0) occu_needs_written=1;
  if(strlen(indi_titl_tmp) >= 2 && strcmp(indi_titl,indi_titl_tmp)!=0) titl_needs_written=1;
  if(strlen(indi_alia_tmp) >= 2 && strcmp(indi_alia,indi_alia_tmp)!=0) alia_needs_written=1;
  if(strlen(indi_dscr_tmp) >= 2 && strcmp(indi_dscr,indi_dscr_tmp)!=0) dscr_needs_written=1;
  if(strlen(indi_addr_tmp) >= 2 && strcmp(indi_addr,indi_addr_tmp)!=0) addr_needs_written=1;
  if(strlen(indi_educ_tmp) >= 2 && strcmp(indi_educ,indi_educ_tmp)!=0) educ_needs_written=1;
  if(strlen(indi_reli_tmp) >= 2 && strcmp(indi_reli,indi_reli_tmp)!=0) reli_needs_written=1;
  if(strlen(indi_note_tmp) >= 2 && strcmp(indi_note,indi_note_tmp)!=0) note_needs_written=1;
  if(strlen(indi_nick_tmp) >= 2 && strcmp(indi_nick,indi_nick_tmp)!=0) nick_needs_written=1;

  if(strlen(indi_birt_date_tmp) >= 2  && strcmp(indi_birt_date,indi_birt_date_tmp)!=0 ) birt_needs_written=1;
  if(strlen(indi_birt_plac_tmp) >= 2  && strcmp(indi_birt_plac,indi_birt_plac_tmp)!=0 ) birt_needs_written=1;
  if(strlen(indi_birt_note_tmp) >= 2  && strcmp(indi_birt_note,indi_birt_note_tmp)!=0 ) birt_needs_written=1;
  if(birt_needs_written==1 && strlen(indi_birt_date_tmp)<=1) strcpy (indi_birt_date_tmp,"n/a");
  if(birt_needs_written==1 && strlen(indi_birt_plac_tmp)<=1) strcpy (indi_birt_plac_tmp,"n/a");
  if(birt_needs_written==1 && strlen(indi_birt_note_tmp)<=1) strcpy (indi_birt_note_tmp,"n/a");

  if(strlen(indi_deat_date_tmp) >= 2  && strcmp(indi_deat_date,indi_deat_date_tmp)!=0 ) deat_needs_written=1;
  if(strlen(indi_deat_plac_tmp) >= 2  && strcmp(indi_deat_plac,indi_deat_plac_tmp)!=0 ) deat_needs_written=1;
  if(strlen(indi_deat_note_tmp) >= 2  && strcmp(indi_deat_note,indi_deat_note_tmp)!=0 ) deat_needs_written=1;
  if(deat_needs_written==1 && strlen(indi_deat_date_tmp)<=1) strcpy (indi_deat_date_tmp,"n/a");
  if(deat_needs_written==1 && strlen(indi_deat_plac_tmp)<=1) strcpy (indi_deat_plac_tmp,"n/a");
  if(deat_needs_written==1 && strlen(indi_deat_note_tmp)<=1) strcpy (indi_deat_note_tmp,"n/a");

  if(strlen(indi_buri_date_tmp) >= 2  && strcmp(indi_buri_date,indi_buri_date_tmp)!=0 ) buri_needs_written=1;
  if(strlen(indi_buri_plac_tmp) >= 2  && strcmp(indi_buri_plac,indi_buri_plac_tmp)!=0 ) buri_needs_written=1;
  if(strlen(indi_buri_note_tmp) >= 2  && strcmp(indi_buri_note,indi_buri_note_tmp)!=0 ) buri_needs_written=1;
  if(buri_needs_written==1 && strlen(indi_buri_date_tmp)<=1) strcpy (indi_buri_date_tmp,"n/a");
  if(buri_needs_written==1 && strlen(indi_buri_plac_tmp)<=1) strcpy (indi_buri_plac_tmp,"n/a");
  if(buri_needs_written==1 && strlen(indi_buri_note_tmp)<=1) strcpy (indi_buri_note_tmp,"n/a");

/// now for updated data ///

  if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }

  //write data
  for(x=0;x<=number_of_lines;x++){
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == atoi(indi_num)) {
        write_indi=1;
        printf("lets write....\n");
      }
      if(indi_r != atoi(indi_num)) write_indi=0;
    }
    //1 NAME
    if(temp[0]=='1' && temp[2]=='N' && temp[3]=='A' && temp[4]=='M' && write_indi==1){
        sprintf(data_line[x],"1 NAME %s\n",indi_name_tmp);
        data_written=1;
        name_written=1;
        strcpy(indi_name,indi_name_tmp);
    }
    //1 TITL
    if(temp[0]=='1' && temp[2]=='T' && temp[3]=='I' && temp[4]=='T' && write_indi==1){
        sprintf(data_line[x],"1 TITL %s\n",indi_titl_tmp);
        data_written=1;
        titl_written=1;
        strcpy(indi_titl,indi_titl_tmp);
    }
    //1 NICK
    if(temp[0]=='1' && temp[2]=='N' && temp[3]=='I' && temp[4]=='C' && write_indi==1){
        sprintf(data_line[x],"1 NICK %s\n",indi_nick_tmp);
        data_written=1;
        nick_written=1;
        strcpy(indi_nick,indi_nick_tmp);
    }

    //1 ALIA
    if(temp[0]=='1' && temp[2]=='A' && temp[3]=='L' && temp[4]=='I' && write_indi==1){
        sprintf(data_line[x],"1 ALIA %s\n",indi_alia_tmp);
        data_written=1;
        alia_written=1;
        strcpy(indi_alia,indi_alia_tmp);
    }


    //1 OCCU 
    if(temp[0]=='1' && temp[2]=='O' && temp[3]=='C' && temp[4]=='C' && write_indi==1){
        sprintf(data_line[x],"1 OCCU %s\n",indi_occu_tmp);
        data_written=1;
        occu_written=1;
        strcpy(indi_occu,indi_occu_tmp);
    }
    //1 EDUC
    if(temp[0]=='1' && temp[2]=='E' && temp[3]=='D' && temp[4]=='U' && write_indi==1){
       sprintf(data_line[x],"1 EDUC %s\n",indi_educ_tmp);
       data_written=1;
       educ_written=1;
       strcpy(indi_educ,indi_educ_tmp);
    }
    //1 ADDR
    if(temp[0]=='1' && temp[2]=='A' && temp[3]=='D' && temp[4]=='D' && temp[5]=='R' && write_indi==1){
       sprintf(data_line[x],"1 ADDR %s\n",indi_addr_tmp);
       data_written=1;
       addr_written=1;
       strcpy(indi_addr,indi_addr_tmp);
    }
    //1 RELI
    if(temp[0]=='1' && temp[2]=='R' && temp[3]=='E' && temp[4]=='L' && write_indi==1){
       sprintf(data_line[x],"1 RELI %s\n",indi_reli_tmp);
       data_written=1;
       reli_written=1;
       strcpy(indi_reli,indi_reli_tmp);
    }
    //1 NOTE
    if(temp[0]=='1' && temp[2]=='N' && temp[3]=='O' && temp[4]=='T' && write_indi==1){
        sprintf(data_line[x],"1 NOTE %s\n",indi_note_tmp);
        data_written=1;
        note_written=1;
        strcpy(indi_note,indi_note_tmp);
    }
   // 1 DSCR
    if(temp[0]=='1' && temp[2]=='D' && temp[3]=='S' && temp[4]=='C' && write_indi==1){
       sprintf(data_line[x],"1 DSCR %s\n",indi_dscr_tmp);
       data_written=1;
       dscr_written=1;
       strcpy(indi_dscr,indi_dscr_tmp);
    }
   // 1 BIRT
    if(temp[0]=='1' && temp[2]=='B' && temp[3]=='I' && temp[4]=='R' && write_indi==1){
       sprintf(data_line[x],"1 BIRT \n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",indi_birt_date_tmp,indi_birt_plac_tmp,indi_birt_note_tmp);
       data_written=1;
       birt_written=1;
       strcpy(indi_birt_date,indi_birt_date_tmp);
       strcpy(indi_birt_plac,indi_birt_plac_tmp);
       strcpy(indi_birt_note,indi_birt_note_tmp);
     }

    
    // 1 DEAT
    if(temp[0]=='1' && temp[2]=='D' && temp[3]=='E' && temp[4]=='A' && write_indi==1){
      deat_needs_written=0;  //temp fix
    }
   // 1 BURI
    if(temp[0]=='1' && temp[2]=='B' && temp[3]=='U' && temp[4]=='R' && write_indi==1){
      buri_needs_written=0;  //temp fix
    }
    //write_data
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);

/// Now for new data ////

 if((fp=fopen(filename,"w"))==NULL ){
     printf("GEDCOM add event : Sorry, no file found. \n");
     exit(0);
  }

  //write data


  for(x=0;x<=number_of_lines;x++){
    strcpy(temp,data_line[x]);

    //is this line an idividual?
    if(temp[0]=='0' && temp[2]=='@' && temp[3]=='I'){
      //if yes, remove unimportant charcters
      //read in the id number
      sprintf(indi,"%c%c%c%c",temp[4],temp[5],temp[6],temp[7]);
      indi_r=atoi(indi);
      //is this the indivudual ?
      if(indi_r == atoi(indi_num)) {
        write_indi=1;
        printf("lets write....\n");
      }
      if(indi_r != atoi(indi_num)) write_indi=0;
    }

    //1 OCCU after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&occu_written==0&&occu_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 OCCU %s\n",temp,indi_occu_tmp);
        strcpy(data_line[x],temp);
        strcpy(indi_occu,indi_occu_tmp);
        data_written=1;
    }

    //1 TITL after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&titl_written==0&&titl_needs_written==1){
        //if yes, write change
       sprintf(temp,"%s1 TITL %s\n",temp,indi_titl_tmp);
       strcpy(data_line[x],temp);
       strcpy(indi_titl,indi_titl_tmp);
        data_written=1;
    }

    //1 NICK after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&nick_written==0&&nick_needs_written==1){
        //if yes, write change
       sprintf(temp,"%s1 NICK %s\n",temp,indi_nick_tmp);
       strcpy(data_line[x],temp);
       strcpy(indi_nick,indi_nick_tmp);
       data_written=1;
    }

    //1 ALIA after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&alia_written==0&&alia_needs_written==1){
        //if yes, write change
       sprintf(temp,"%s1 ALIA %s\n",temp,indi_alia_tmp);
       strcpy(data_line[x],temp);
       strcpy(indi_alia,indi_alia_tmp);
       data_written=1;
    }



    //1 DSCR after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&dscr_written==0&&dscr_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 DSCR %s\n",temp,indi_dscr_tmp);
        strcpy(data_line[x],temp);
        strcpy(indi_dscr,indi_dscr_tmp); 
        data_written=1;
    }

    //1 ADDR after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&addr_written==0&&addr_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 ADDR %s\n",temp,indi_addr_tmp);
        strcpy(data_line[x],temp);
        strcpy(indi_addr,indi_addr_tmp);
        data_written=1;
    }

    //1 EDUC after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&educ_written==0&&educ_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 EDUC %s\n",temp,indi_educ_tmp);
        strcpy(data_line[x],temp);
        strcpy(indi_educ,indi_educ_tmp);
        data_written=1;
    }

    //1 RELI after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&reli_written==0&&reli_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 RELI %s\n",temp,indi_reli_tmp);
        strcpy(data_line[x],temp);
        strcpy(indi_reli,indi_reli_tmp);
        data_written=1;
    }

    //1 NOTE after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&note_written==0&&note_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 NOTE %s\n",temp,indi_note_tmp);
        strcpy(data_line[x],temp);
        strcpy(indi_note,indi_note_tmp);
        data_written=1;
    }

    //1 BIRT after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&birt_written==0&&birt_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 BIRT\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_birt_date_tmp,indi_birt_plac_tmp,indi_birt_note_tmp);
        printf("%s1 BIRT\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_birt_date_tmp,indi_birt_plac_tmp,indi_birt_note_tmp);
        strcpy(data_line[x],temp);
        data_written=1;
    }
    //1 DEAT after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&deat_written==0&&deat_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 DEAT\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_deat_date,indi_deat_plac,indi_deat_note);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //1 BURI after 1 SEX
    if(temp[0]=='1'&&temp[2]=='S'&&temp[3]=='E'&&temp[4]=='X'&& write_indi==1&&buri_written==0&&buri_needs_written==1){
        //if yes, write change
        sprintf(temp,"%s1 BURI\n2 DATE %s\n2 PLAC %s\n2 NOTE %s\n",temp,indi_buri_date,indi_buri_plac,indi_buri_note);
        strcpy(data_line[x],temp);
        data_written=1;
    }

    //write_data
    fprintf(fp,"%s",data_line[x]);
  }//end for
  fclose(fp);

  if(data_written==1) x_msgbox(5,"Data has been saved","Saved","fixed",50);

}


//////////////////////////////////
// add spouce
////////////////////////////////////////
void add_spouce(void)
{
  char spouce_string[90];
  if(indi_sex[0]=='F')
    sprintf(spouce_string,"./gedadd_spouce %s %s M",indi_num,filename);
  if(indi_sex[0]=='M')
    sprintf(spouce_string,"./gedadd_spouce %s %s F",indi_num,filename);
  system(spouce_string);

}


//////////////////////////////////////////////////
// main
/////////////////////////////////////////////////
int main(int argc, char **argv){

  char last_action[15];


  char input1[95], input2[95];
  //int individual;
  int button_01, button_02, button_03, button_04, button_05;
  int button_06, button_07, button_08;
  int label0,label1,label2,label3,label4,label5,label6;
  int label7,label8,label9,label10,label11, label12, label13;
  int label14, label15, label16, label17, label18, label19;
  int label21;
  int readflag=0;
  int x=0;
  int line=5;
  int indi_found=0;

  int loopy=0;

  FILE *fp5;

  strcpy(filename, argv[1]);
  strcpy(indi_num, argv[2]);
  strcpy(indi_name,"\0");
  strcpy(indi_nick,"\0");
  strcpy(indi_alia,"\0");
  strcpy(indi_note,"\0");
  strcpy(indi_birt_plac,"\0");
  strcpy(indi_birt_date,"\0");
  strcpy(indi_birt_note,"\0");
  strcpy(indi_deat_plac,"\0");
  strcpy(indi_deat_date,"\0");
  strcpy(indi_deat_note,"\0");
  strcpy(indi_buri_plac,"\0");
  strcpy(indi_buri_date,"\0");
  strcpy(indi_buri_note,"\0");
  strcpy(indi_addr,"\0"); 
  strcpy(indi_educ,"\0");
  strcpy(indi_occu,"\0");
  strcpy(indi_reli,"\0");
  strcpy(indi_titl,"\0");
  strcpy(indi_dscr,"\0");

  mark_indi();

  fp5=fopen(argv[1],"r+");

  x_open();

  /* create a new window */
  gdx_window("GEDCOM Individual",790,520);
  gdx_setwindowbg("images/bg.xpm",1);


  gdx_frame(50,18,780,475,"Individual data for GEDCOM ID:");

  button_01 = gdx_imagebutton(5,18,"images/close.xpm",destroy);
  button_06 = gdx_imagebutton(5,48,"images/filesave.xpm",save);
  button_08 = gdx_imagebutton(45,485,"images/submit.xpm",save);
  button_02 = gdx_imagebutton(5,78,"images/pari.xpm",parent);
  button_03 = gdx_imagebutton(5,108,"images/chil.xpm",family);
  button_04 = gdx_imagebutton(5,138,"images/marr.xpm",add_spouce);
  button_05 = gdx_imagebutton(5,168,"images/help.xpm",help);

  label0 = gdx_label(argv[2],232,15,1);
  gdx_setlabelbg("images/white.xpm",1,label0);

  printf("%s %s %s\n",argv[0],argv[1],argv[2]);

  //main start of read

  do{
    //check for level 0
    fgets(input1,80,fp5);

    //store all data for later use
    strcpy(data_line[loopy],input1);
    loopy++;

     //01234567890123
     //0 @I0001@ INDI
     if(input1[0]=='0'&& input1[2]=='@' && input1[3]=='I' && input1[10]=='I' && input1[11]=='N'){

        //Great!, the level 0 is an individual

        for(x=5;x<80;x++) if(input1[x]=='@' ||input1[x]=='I') input1[x]=' ';
        sprintf(indi_check,"%c%c%c%c",input1[4],input1[5],input1[6],input1[7]);

        //check to see if it is the idividual we are looking for 
        if(atoi(indi_check)==atoi(argv[2])){
          //hot grits! it is the idividual we were looking for
          readflag=1;
        }
        else readflag=0;
     }// end if indi found

      if(input1[0]=='1' && input1[2]=='N' && input1[3]=='A' && readflag==1){     ///1 NAME
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_name,input1);
      }

      if(input1[0]=='1' && input1[2]=='T' && input1[3]=='I' && input1[4]=='T' && readflag==1){     ///1 TITL
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_titl,input1);
      }

      if(input1[0]=='1' && input1[2]=='N' && input1[3]=='O' && readflag==1){     ///1 NOTE
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_note,input1);
      }

      if(input1[0]=='1' && input1[2]=='D' && input1[3]=='S'&&readflag==1){     ///1 DSCR
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_dscr,input1);
      }

      if(input1[0]=='1' && input1[2]=='S' && input1[3]=='E' &&readflag==1){   ///1 SEX
        indi_sex[0]=input1[6];
        indi_sex[1]='\0';
      }



      if(input1[0]=='1' && input1[2]=='N' && input1[3]=='I' && input1[4]=='C' && readflag==1){     ///1 NICK
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_nick,input1);
      }

      if(input1[0]=='1' && input1[2]=='A' && input1[3]=='L' && input1[4]=='I' && readflag==1){     ///1 ALIA
        for(x=7;x<80;x++){
          if(input1[x]=='\n') input1[x]='\0';
          input1[x-7]=input1[x];}
        strcpy(indi_alia,input1);
      }



// last actions


      if(input1[0]=='1' && input1[2]=='M' && input1[3]=='A' && input1[4] =='R' &&readflag==1){ //1 MARR
         strcpy(last_action,"MARR");
      }

      if(input1[0]=='1' && input1[2]=='D' && input1[3]=='I' && input1[4] =='V' &&readflag==1){ //1 DIV 
         strcpy(last_action,"DIV ");
      }

      if(input1[0]=='1' && input1[2]=='C' && input1[3]=='H' && input1[4] =='A' &&readflag==1){ //1 CHAN
         strcpy(last_action,"CHAN");
      }

      if(input1[0]=='1' && input1[2]=='E' && input1[3]=='V' && input1[4] =='E'&&readflag==1){ //1 EVEN
         strcpy(last_action,"EVEN");
      }

      if(input1[0]=='1' && input1[2]=='B' && input1[3]=='U' && input1[4] =='R'&&readflag==1){ //1 BURI
        strcpy(last_action,"BURI");
      }

      if(input1[0]=='1' && input1[2]=='C' && input1[3]=='R' && input1[4] =='E'&&readflag==1){ //1 CREM
        strcpy(last_action,"CREM");
      }

      if(input1[0]=='1' && input1[2]=='B' && input1[3]=='I'&&readflag==1){ //1 BIRT
         strcpy(last_action,"BIRT");
      }

      if(input1[0]=='1' && input1[2]=='D' && input1[3]=='E' && input1[4] =='A'&&readflag==1){ //1 DEAT
        strcpy(last_action,"DEAT");
      }

// Birth Date, Burial Date, and Death Date

       if(input1[0]=='2' && input1[2]=='D' && input1[3]=='A'&&readflag==1){ //2 DATE
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='B' && last_action[1]=='U'&&readflag==1){
            strcpy(indi_buri_date,input1);
          }
          if(last_action[0]=='B' && last_action[1]=='I'&&readflag==1){
            strcpy(indi_birt_date,input1);
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_date,input1);
          }
       }

// Brith Place, Death Place, Burial Place
 
       if(input1[0]=='2' && input1[2]=='P' && input1[3]=='L'&&readflag==1){ //2 PLAC
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='B' && last_action[1]=='I'&&readflag==1){
            strcpy(indi_birt_plac,input1);
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_plac,input1);
          }
          if(last_action[0]=='B' && last_action[1]=='U'&&readflag==1){
            strcpy(indi_buri_plac,input1);
          }
       }


// Brith Note, Burial Note, and Death Note

       if(input1[0]=='2' && input1[2]=='N' && input1[3]=='O'&&readflag==1){ //2 Note 
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];
          }
          if(last_action[0]=='B' && last_action[1]=='I'&&readflag==1){
            strcpy(indi_birt_note,input1);
          }
          if(last_action[0]=='B' && last_action[1]=='U'&&readflag==1){
            strcpy(indi_buri_note,input1);
          }
          if(last_action[0]=='D' && last_action[1]=='E'&&readflag==1){
            strcpy(indi_deat_note,input1);
          }
       }



/// Address
        if(input1[0]=='1' && input1[2]=='A' && input1[3]=='D' && input1[4]=='D' && input1[5]=='R' && readflag==1){    
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];}
          strcpy(indi_addr,input1);
        }

// Occupation
        if(input1[0]=='1' && input1[2]=='O' && input1[3]=='C' &&readflag==1){   
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];}
          strcpy(indi_occu,input1);
        }

// Education
        if(input1[0]=='1' && input1[2]=='E' && input1[3]=='D' &&readflag==1){    
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];}
          strcpy(indi_educ,input1);
        }

// Religon
       if(input1[0]=='1' && input1[2]=='R' && input1[3]=='E' && readflag==1){   
          for(x=7;x<80;x++){
            if(input1[x]=='\n') input1[x]='\0';
            input1[x-7]=input1[x];}
          strcpy(indi_reli,input1);
       }

  }while(input1[0] !='0' || input1[2] !='T');

  number_of_lines=loopy;

  //display
  //Name
  label1 = gdx_label("Name:",55,35,0);
  gdx_setlabelbg("images/bg.xpm",1,label1);
  indi_name_t=gdx_textentry(140,25,250,0);
  gdx_settextentry(indi_name_t,indi_name);
  if(indi_name_m==0)flex_name=gdx_imagebutton(400,23,"images/update.xpm",mark_name);
  if(indi_name_m==1)flex_name=gdx_imagebutton(400,23,"images/update2.xpm",mark_name);

  label2 = gdx_label("Title:",55,60,0);
  gdx_setlabelbg("images/bg.xpm",1,label2);
  indi_titl_t=gdx_textentry(140,50,200,0);
  gdx_settextentry(indi_titl_t,indi_titl);
  if(indi_titl[0]=='\0'){
    gdx_image(350,48,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_titl_m==0)flex_titl=gdx_imagebutton(350,48,"images/update.xpm",mark_titl);
    if(indi_titl_m==1)flex_titl=gdx_imagebutton(350,48,"images/update2.xpm",mark_titl);
  }

  //Sex
  label3=gdx_label("Sex:",55,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label3);
  indi_sex_t=gdx_textentry(140,75,20,0);
  gdx_settextentry(indi_sex_t,indi_sex);

  label19=gdx_label("Nickname:",200,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label19);
  indi_nick_t=gdx_textentry(265,75,180,0);
  gdx_settextentry(indi_nick_t,indi_nick);

  label21=gdx_label("Alias:",450,85,0);
  gdx_setlabelbg("images/bg.xpm",1,label21);
  indi_alia_t=gdx_textentry(505,75,180,0);
  gdx_settextentry(indi_alia_t,indi_alia);


  //Dascription
  label4=gdx_label("Description:",55,110,0);
  gdx_setlabelbg("images/bg.xpm",1,label4);
  indi_dscr_t=gdx_textentry(140,100,350,0);
  gdx_settextentry(indi_dscr_t,indi_dscr);
  if(indi_dscr[0]=='\0'){
    gdx_image(500,98,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_dscr_m==0)flex_dscr=gdx_imagebutton(500,98,"images/update.xpm",mark_dscr);
    if(indi_dscr_m==1)flex_dscr=gdx_imagebutton(500,98,"images/update2.xpm",mark_dscr);
  }


  label13 = gdx_label("Occupation:",55,140,0);
  gdx_setlabelbg("images/bg.xpm",1,label13);
  indi_occu_t=gdx_textentry(140,125,350,0);
  gdx_settextentry(indi_occu_t,indi_occu);
  if(indi_occu[0]=='\0'){
    gdx_image(500,123,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_occu_m==0)flex_occu=gdx_imagebutton(500,123,"images/update.xpm",mark_occu);
    if(indi_occu_m==1)flex_occu=gdx_imagebutton(500,123,"images/update2.xpm",mark_occu);
  }

  label14 = gdx_label("Education:",55,160,0);
  gdx_setlabelbg("images/bg.xpm",1,label14);
  indi_educ_t=gdx_textentry(140,150,350,0);
  gdx_settextentry(indi_educ_t,indi_educ);
  if(indi_educ[0]=='\0'){
    gdx_image(500,148,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_educ_m==0)flex_educ=gdx_imagebutton(500,148,"images/update.xpm",mark_educ);
    if(indi_educ_m==1)flex_educ=gdx_imagebutton(500,148,"images/update2.xpm",mark_educ);
  }


  label15 = gdx_label("Religon:",55,185,0);
  gdx_setlabelbg("images/bg.xpm",1,label15);
  indi_reli_t=gdx_textentry(140,175,350,0);
  gdx_settextentry(indi_reli_t,indi_reli);
  if(indi_reli[0]=='\0'){
    gdx_image(500,173,"images/tree_info.xpm");
  }
  else{
    //gdx_image(500,173,"images/update.xpm");
    if(indi_reli_m==0)flex_reli=gdx_imagebutton(500,173,"images/update.xpm",mark_reli);
    if(indi_reli_m==1)flex_reli=gdx_imagebutton(500,173,"images/update2.xpm",mark_reli);
  }


  label12 = gdx_label("Address:",55,210,0);
  gdx_setlabelbg("images/bg.xpm",1,label12);
  indi_addr_t=gdx_textentry(140,200,350,0);
  gdx_settextentry(indi_addr_t,indi_addr);
  if(indi_addr[0]=='\0'){
    gdx_image(500,198,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_addr_m==0)flex_addr=gdx_imagebutton(500,198,"images/update.xpm",mark_addr);
    if(indi_addr_m==1)flex_addr=gdx_imagebutton(500,198,"images/update2.xpm",mark_addr);
  }

  label5 = gdx_label("General Note:",55,235,0);
  gdx_setlabelbg("images/bg.xpm",1,label5);
  indi_note_t=gdx_textentry(140,225,350,0);
  gdx_settextentry(indi_note_t,indi_note);
  if(indi_note[0]=='\0'){
    gdx_image(500,223,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_note_m==0)flex_note=gdx_imagebutton(500,223,"images/update.xpm",mark_note);
    if(indi_note_m==1)flex_note=gdx_imagebutton(500,223,"images/update2.xpm",mark_note);
  }

  //Birth Date
  label6=gdx_label("Birth Date:",55,285,0);
  gdx_setlabelbg("images/bg.xpm",1,label6);
  indi_birt_date_t=gdx_textentry(140,275,100,0);
  gdx_settextentry(indi_birt_date_t,indi_birt_date);
  //printf("birthdate set:%s \n",indi_birt_date);

  if(indi_birt_date[0]=='\0'){
    gdx_image(250,273,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_birt_date_m==0)flex_birt_date=gdx_imagebutton(250,273,"images/update.xpm",mark_birt_date);
    if(indi_birt_date_m==1)flex_birt_date=gdx_imagebutton(250,273,"images/update2.xpm",mark_birt_date);
  }

  //Birth Place
  label7=gdx_label("Birth Place:",295,285,0);
  gdx_setlabelbg("images/bg.xpm",1,label7);
  indi_birt_plac_t=gdx_textentry(380,275,350,0);
  gdx_settextentry(indi_birt_plac_t,indi_birt_plac);
  if(indi_birt_plac[0]=='\0'){
    gdx_image(740,273,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_birt_plac_m==0)flex_birt_plac=gdx_imagebutton(740,273,"images/update.xpm",mark_birt_plac);
    if(indi_birt_plac_m==1)flex_birt_plac=gdx_imagebutton(740,273,"images/update2.xpm",mark_birt_plac);
  }

  label8 = gdx_label("Birth Note:",55,310,0);
  gdx_setlabelbg("images/bg.xpm",1,label8);
  indi_birt_note_t=gdx_textentry(140,300,350,0);
  gdx_settextentry(indi_birt_note_t,indi_birt_note);
  

  if(indi_birt_note[0]=='\0'){
    gdx_image(500,298,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_birt_note_m==0)flex_birt_note=gdx_imagebutton(500,298,"images/update.xpm",mark_birt_note);
    if(indi_birt_note_m==1)flex_birt_note=gdx_imagebutton(500,298,"images/update2.xpm",mark_birt_note);
  }


  //Death Date
  label9=gdx_label("Death Date:",55,355,0);
  gdx_setlabelbg("images/bg.xpm",1,label9);
  indi_deat_date_t=gdx_textentry(140,345,100,0);
  gdx_settextentry(indi_deat_date_t,indi_deat_date);
  if(indi_deat_date[0]=='\0'){
    gdx_image(250,342,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_deat_date_m==0)flex_deat_date=gdx_imagebutton(250,342,"images/update.xpm",mark_deat_date);
    if(indi_deat_date_m==1)flex_deat_date=gdx_imagebutton(250,342,"images/update2.xpm",mark_deat_date);
  }

  //Death Place
  label10=gdx_label("Death Place:",295,355,0);
  gdx_setlabelbg("images/bg.xpm",1,label10);
  indi_deat_plac_t=gdx_textentry(380,345,350,0);
  gdx_settextentry(indi_deat_plac_t,indi_deat_plac);
  if(indi_deat_plac[0]=='\0'){
    gdx_image(740,342,"images/tree_info.xpm");
  }

  label11 = gdx_label("Death Note:",55,380,0);
  gdx_setlabelbg("images/bg.xpm",1,label11);
  indi_deat_note_t=gdx_textentry(140,370,350,0);
  gdx_settextentry(indi_deat_note_t,indi_deat_note);
  if(indi_deat_note[0]=='\0'){
    gdx_image(500,368,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_deat_note_m==0)flex_deat_note=gdx_imagebutton(500,368,"images/update.xpm",mark_deat_note);
    if(indi_deat_note_m==1)flex_deat_note=gdx_imagebutton(500,368,"images/update2.xpm",mark_deat_note);
  }

  label16 = gdx_label("Burial date:",55,425,0);
  gdx_setlabelbg("images/bg.xpm",1,label16);
  indi_buri_date_t=gdx_textentry(140,415,100,0);
  gdx_settextentry(indi_buri_date_t,indi_buri_date);
  if(indi_buri_date[0]=='\0'){
    gdx_image(250,412,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_buri_date_m==0)flex_buri_date=gdx_imagebutton(250,412,"images/update.xpm",mark_buri_date);
    if(indi_buri_date_m==1)flex_buri_date=gdx_imagebutton(250,412,"images/update2.xpm",mark_buri_date);
  }

  label17 = gdx_label("Burial Place:",295,425,0);
  gdx_setlabelbg("images/bg.xpm",1,label17);
  indi_buri_plac_t=gdx_textentry(380,415,350,0);
  gdx_settextentry(indi_buri_plac_t,indi_buri_plac);
  if(indi_buri_plac[0]=='\0'){
    gdx_image(740,412,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_buri_plac_m==0)flex_buri_plac=gdx_imagebutton(740,412,"images/update.xpm",mark_buri_plac);
    if(indi_buri_plac_m==1)flex_buri_plac=gdx_imagebutton(740,412,"images/update2.xpm",mark_buri_plac);
  }


  label18 = gdx_label("Burial Note:",55,450,0);
  gdx_setlabelbg("images/bg.xpm",1,label18);
  indi_buri_note_t=gdx_textentry(140,440,350,0);
  gdx_settextentry(indi_buri_note_t,indi_buri_note);
  if(indi_buri_note[0]=='\0'){
    gdx_image(500,438,"images/tree_info.xpm");
  }
  else{
    printf(" ");
    if(indi_buri_note_m==0)flex_buri_note=gdx_imagebutton(500,438,"images/update.xpm",mark_buri_note);
    if(indi_buri_note_m==1)flex_buri_note=gdx_imagebutton(500,438,"images/update2.xpm",mark_buri_note);
  }



  gdx_main();
  x_close();

  return(0);
}

